from pandac.PandaModules import *


class Level:
  def __init__(self,ode):
    # Set background...
    base.setBackgroundColor(0.0,0.0,0.0)

    # Load the level...
    self.level = loader.loadModel('data/level')
    self.level.flattenStrong()
    self.level.reparentTo(render)

    # Make the level solid...
    self.levelGeom = OdeTriMeshGeom(ode.getSpace(),OdeTriMeshData(self.level,True))

    # Setup lighting on the level - it has a lightmap but we ada directional light anyway for some specularities...
    self.ambLight = AmbientLight('ambient')
    self.ambLight.setColor(Vec4(0.7,0.7,0.7,1.0))
    self.ambNode = render.attachNewNode(self.ambLight)
    self.level.setLight(self.ambNode)

    self.dir = DirectionalLight('dir')
    self.dir.setColor(VBase4(0.8,0.8,0.8,1.0))
    self.dirNode = render.attachNewNode(self.dir)
    self.level.setLight(self.dirNode)
    self.dirNode.setPos(10.0,10.0,10.0)
    self.dirNode.lookAt(render)


