from pandac.PandaModules import *

import sys
import math


class Victory:
  """Detects when victory occurs - does an incirmental test over time. Also loads the victory info and indicates the victory areas."""
  def __init__(self,proMan,stats):
    self.proMan = proMan
    self.stats = stats
    
    self.inKettles = 0
    self.targPerc = 0.9

    # Load the kettling zones, create zone indicators...
    locs = loader.loadModel('data/locations')
    nodes = locs.findAllMatches('**/=IsA=Kettle')
    self.kettles = [] # Tuples (minX,maxX,minY,maxY)
    for i in xrange(nodes.size()):
      node = nodes[i]
      width = float(node.getTag('Width'))
      height = float(node.getTag('Height'))
      # Store region for testing...
      self.kettles.append((node.getX()-width*0.5, node.getX()+width*0.5, node.getY()-height*0.5, node.getY()+height*0.5))

      # Create indicator of region...
      r = loader.loadModel('data/region')
      r.reparentTo(render)
      r.setSx(width)
      r.setSy(height)
      r.setX(node.getX())
      r.setY(node.getY())
      r.setTransparency(TransparencyAttrib.MDual)
      r.setLightOff()

    def checkVictory(task):
      while True:
        pl = map(lambda x:x[1],self.proMan.pList.iteritems())
        yield task.cont

        inK = 0
        for i,p in enumerate(pl):
          if not p.mesh.isEmpty():
            # Test if the protestor in question is inside one of the kettle zones...
            xp = p.mesh.getX()
            yp = p.mesh.getY()
            for k in self.kettles:
              if xp>k[0] and xp<k[1] and yp>k[2] and yp<k[3]:
                inK += 1
                break
          if i%50==0: yield task.cont
        self.inKettles = inK
        if len(pl)>100 and float(inK)/float(len(pl))>self.targPerc:
          # We have victory (Approximatly)...
          print 'Victory!' ################################
        yield task.cont

    taskMgr.add(checkVictory,"CheckVictory")
  