import direct.directbase.DirectStart
from direct.showbase import DirectObject
from pandac.PandaModules import *

import sys

from bin.ode import *
from bin.level import *
from bin.lighting import *
from bin.camera import *
from bin.bobbles import *
from bin.routing import *
from bin.protestor import *
from bin.police import *
from bin.mouse import *
from bin.stats import *
from bin.victory import *


class Killer(DirectObject.DirectObject):
  def __init__(self):
    self.accept('escape',sys.exit)
Killer()


lighting = Lighting()
camera = CamControl(-20.0,20.0,-20.0,20.0)

ode = Ode()

level = Level(ode)
routing = Routing()

stats = Stats()

bobbles = Bobbles(ode,lighting)
protestorMan = ProtestorManager(bobbles,routing,stats)
policeMan = PoliceMan(bobbles,stats)

stats.bodyToAI = bobbles.bodyToAI

mouse = Mouse(policeMan)
victory = Victory(protestorMan,stats)


run()